Bug 1154059 - curl: Disable out-of-protocol fallback to SSL 3.0
Summary: curl: Disable out-of-protocol fallback to SSL 3.0
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: curl
Version: 6.5
Hardware: Unspecified
OS: Unspecified
high
high
Target Milestone: rc
: ---
Assignee: Kamil Dudka
QA Contact: Stefan Kremen
URL:
Whiteboard:
Depends On: 1154060
Blocks: 1159820 1159926
TreeView+ depends on / blocked
 
Reported: 2014-10-17 12:26 UTC by Florian Weimer
Modified: 2015-07-22 05:43 UTC (History)
6 users (show)

Fixed In Version: curl-7.19.7-43.el6
Doc Type: Deprecated Functionality
Doc Text:
Previously, libcurl implemented an out-of-protocol fallback to SSL 3.0 (Secure Sockets Layer) in order to securely communicate with TLS (Transport Layer Security) intolerant servers. This could have been abused by an attacker to force downgrade of the SSL version. Therefore, this feature has been removed from libcurl. Users of libcurl that have been relying on this feature are advised to explicitly enable SSL 3.0 by the --sslv3 option of curl (or the CURL_SSLVERSION_SSLv3 constant of libcurl API) to prevent connection failures when TLS intolerant servers are involved.
Clone Of:
: 1154060 (view as bug list)
Environment:
Last Closed: 2015-07-22 05:43:47 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2015:1254 normal SHIPPED_LIVE Moderate: curl security, bug fix, and enhancement update 2015-07-20 17:50:03 UTC
Red Hat Bugzilla 1152789 None None None Never

Internal Links: 1152789

Description Florian Weimer 2014-10-17 12:26:15 UTC
We should disable the retry-with-SSL-3.0 behavior in curl because it can be trivially triggered by an on-path attacker to cause a protocol downgrade, and SSL 3.0 has several known weaknesses.  This curl behavior is quite surprising because it is restricted to the NSS backend, and other systems which use the OpenSSL or GNUTLS backend do not share this behavior.

At this stage, it is best to leave SSL 3.0 enabled.  (The in-protocol version negotiation has not been broken, sosome TLS version will be used automatically if supported by the server.)

This might reintroduce bug 525496 and bug 527771, so a system-wide knob to re-enable the SSL 3.0 fallback might be necessary.  Perhaps the existence of a file like /etc/sysconfig/curl/enable-ssl-fallback could re-enable the old behavior.

Comment 3 Tomas Hoger 2014-10-23 16:02:06 UTC
(In reply to Florian Weimer from comment #0)
> This might reintroduce bug 525496 and bug 527771, so a system-wide knob to
> re-enable the SSL 3.0 fallback might be necessary.  Perhaps the existence of
> a file like /etc/sysconfig/curl/enable-ssl-fallback could re-enable the old
> behavior.

Or environment variable?  CURL_ENABLE_SSL_FALLBACK?

Do curl try to fall back across multiple versions (TLS 1.1 -> TLS 1.0 -> SSL 3.0), or if connection attempt with the highest supported fails, it goes straight to SSL 3.0?

Comment 4 Kamil Dudka 2014-10-23 16:06:58 UTC
(In reply to Tomas Hoger from comment #3)
> Or environment variable?  CURL_ENABLE_SSL_FALLBACK?

That would also work I guess.

> Do curl try to fall back across multiple versions (TLS 1.1 -> TLS 1.0 -> SSL
> 3.0), or if connection attempt with the highest supported fails, it goes
> straight to SSL 3.0?

The fallback implemented by libcurl goes straight to SSL 3.0.

Comment 12 errata-xmlrpc 2015-07-22 05:43:47 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2015-1254.html


Note You need to log in before you can comment on or make changes to this bug.